/* 
 * File:   dcoder.h
 * Author: fjkraan
 *
 * Created on December 27, 2012, 9:41 AM
 */

#ifndef DECODER_H
#define	DECODER_H

#ifdef	__cplusplus
extern "C" {
#endif

// variables used in process_bit
typedef struct {
    unsigned long long accum;
    unsigned long long taccum;
    int bits;
    int ibyte;
    int dbyte;
    
    unsigned char premark;
    int mark_after;
    int curenc;
    unsigned short crc;
    int sizecode;
    int first_encoding;
    int write_splice;
    int cwclock;
    int fmthresh;
    int mfmthresh1;
    int mfmthresh2;
    int dmktracklen;
    int uencoding;
    int backward_am;
    int good_sectors;
    int errcount;  
    float mfmshort;
    float postcomp;  
    int index_edge;
    int hole;
    int maxsize;
} DecoderParams_t;

/* Constants and globals for decoding */
#define FM 1
#define MFM 2
#define RX02 3
#define MIXED 0
#define N_ENCS 4

// change_eng, main
char *enc_name[] = { "autodetect", "FM", "MFM", "RX02" };

// dmk_write, dmk_init_track, process_bit
int enc_count[N_ENCS];

// dmk_write, process_bit, main
int total_enc_count[N_ENCS];



#ifdef	__cplusplus
}
#endif

#endif	/* DECODER_H */

